public class Hailstone {
	public static void main(String[] args) {
		int[] array = hailstone(5);

		System.out.println("array.length = " + array.length);
		for(int i = 0; i < array.length; i++) {
			System.out.println("array[" + i + "] = " + array[i]);
		}
	}

	public static int[] hailstone(int x) {
		//the hailstone sequence is an interesting mathematic sequence
		//if the previous number on the sequence is x, then the next number will be:
		// x / 2     if x is even
		// 3 * x + 1 if x is odd
		//given a starting number x, your task is to return an array of the first 1000 numbers
		// in the hailstone sequence of x
		//for example, if the input is 5, you should return:
		// [5, 16, 8, 4, 2, 1, 4, 2, 1, 4, 2, 1, 4, 2, 1, 4, 2, 1, ...]
		int[] hailstone = new int[1000]; //initialize an array of length 1000

		for(int i = 0; i < 1000; i++) { //repeat 1000 times; the index is used only for the slot in the array to record number
			hailstone[i] = x;
			if(x % 2 == 0) { //if x is even, since it's remainder after dividing by 2 is 0
				x /= 2; //x = x / 2, divide x by 2
			} else { //if x is not even it must be odd (remember that x is an integer, defined in the function parameter)
				x = 3 * x + 1;
			}
		}

		return hailstone;
	}
}
